-- Credits: 
-- Rueven - Director, rigging, materials, and main spriter/animator.
-- Cherry - Co-director, programmer.
-- Nugget - Modeler.
-- Other Chen - Programmed the base for Mario's crouch.
-- Golden Shine - Made the player collision example code, which served as a base for bumper and booster collision.
-- Lach (for Junio Sonic) - Ported the spindash dust code and programmed the base for crouch and Jump Special checking.
-- Water Vapor - Sprited Mario's ending constellation.
-- Dokotroopi - Made the MARIO font for the CSS.
-- Audio is from Super Mario 64 and Paper Mario: the Thousand Year Door.

freeslot (
"S_PLAY_DUCK",
"S_PLAY_CRSD",
"S_PLAY_CRMV",
"SPR_PLAY",
"SPR2_DUCK",
"SPR2_SGCB",
"SPR2_SGCL",
"sfx_sgrol",
"sfx_sgrls",
"sfx_sgpds",
"sfx_sgjmp",
"sfx_sglnd",
"sfx_sgpnd",
"sfx_sgmld",
"sfx_sgmjm",
"sfx_sgspg",
"sfx_sgjm1",
"sfx_sgjm2",
"sfx_sgjm3",
"sfx_sgjm4",
"sfx_sgjm5",
"sfx_sgjm6",
"sfx_sght1",
"sfx_sght2",
"sfx_sgsp1",
"sfx_sgsp2",
"sfx_sgsp3",
"sfx_sgtfm",
"sfx_sglng",
"sfx_sgwkc",
"sfx_sgmwk",
"sfx_sgkfl",
"sfx_sgiwk",
"sfx_sglwk",
"sfx_sgsws",
"sfx_sgswm",
"sfx_sgswj",
"sfx_sgswd",
"sfx_frerol",
"sfx_sgimjump",
"S_PLAY_GPST",
"S_PLAY_GRPD",
"S_PLAY_GPLD",
"S_PLAY_LGST",
"S_PLAY_LNGE",
"S_PLAY_LGFL",
"S_PLAY_SWST",
"S_PLAY_SWIM",
"S_PLAY_SWJP",
"S_PLAY_SWID",
"S_PLAY_SWDG",
"S_PLAY_SWDR",
"S_PLAY_UWDG",
"S_PLAY_KFAL",
"S_PLAY_WPCH",
"S_PLAY_WKCK",
"SPR2_GPST",
"SPR2_GRPD",
"SPR2_GPLD",
"SPR2_LGST",
"SPR2_LNGE",
"SPR2_LGFL",
"SPR2_SWST",
"SPR2_SWID",
"SPR2_SWIM",
"SPR2_SWJP",
"SPR2_SWDG",
"SPR2_SWDR",
"SPR2_BONK",
"SPR2_SGWP",
"SPR2_SGWJ",
"SPR2_SHIT"
)

//lol array
//local crawlTypes = {S_PLAY_DUCK, S_PLAY_CRSD, S_PLAY_CRMV}
//LOL FUNCTIONS
local SGIMReset
local SGICrouchBegin
local SGIPoundBegin
local SGIPassive
local DoSpinDashDust
local SGICrouching
local SGIJump
local SGIHurt
local SGISpring
local WASDAngle -- adjust angle based on movement keys, not actual movement direction
local PlayerBrake -- subtract 1/f from object's speed, or 2/f if underwater
local PlayerSpeed -- p.speed corrected for scale
local PlayerTransforming
local SGIBlockBust
//drill bubble array
local drlBubbles = {MT_MEDIUMBUBBLE, MT_SMALLBUBBLE}
//make array for the 409843095 jump voices
local jumpVoice = {sfx_sgjm1, sfx_sgjm2, sfx_sgjm3, sfx_sgjm4, sfx_sgjm5, sfx_sgjm6} 
local hurtVoice = {sfx_sght1, sfx_sght2} 
local springVoice = {sfx_sgsp1, sfx_sgsp2, sfx_sgsp3}

local IsSpinning = false
local CrouchSpeed = 0

states[S_PLAY_DUCK] = {
        sprite = SPR_PLAY,
        frame = SPR2_DUCK,
        tics = -1,
}

states[S_PLAY_CRSD] = {
        sprite = SPR_PLAY,
        frame = SPR2_SGCB,
        tics = -1,
}
states[S_PLAY_CRMV] = {
        sprite = SPR_PLAY,
        frame = SPR2_SGCL|A,
        tics = -1,
}
states[S_PLAY_GPST] = {
		sprite = SPR_PLAY,
		frame = FF_ANIMATE|SPR2_GPST,
		var1 = 11,
		var2 = 1,
		tics = 12,
		nextstate = S_PLAY_GRPD
}
states[S_PLAY_GRPD] = {
		sprite = SPR_PLAY,
		frame = SPR2_GRPD,
		action = A_ZThrust,
		var1 = -38,
		var2 = 11,
		tics = 105,
		nextstate = S_PLAY_FALL
}
states[S_PLAY_GPLD] = {
		sprite = SPR_PLAY,
		frame = SPR2_GPLD,
		var1 = -38,
		var2 = 11,
		tics = -1,
}
states[S_PLAY_LNGE] = {
		sprite = SPR_PLAY,
		frame = FF_ANIMATE|SPR2_LNGE,
		var1 = 11,
		var2 = 1,
		tics = 6,
		nextstate = S_PLAY_LGFL
}
states[S_PLAY_LGFL] = {
		sprite = SPR_PLAY,
		frame = SPR2_LGFL,
		var1 = -38,
		var2 = 11,
		tics = -1,
		
}
states[S_PLAY_LGST] = {
		sprite = SPR_PLAY,
		frame = SPR2_LGST,
		var1 = -38,
		var2 = 11,
		tics = 17,
		nextstate = S_PLAY_LNGE
}
states[S_PLAY_SWST] = {
		sprite = SPR_PLAY,
		frame = SPR2_SWST,
		var1 = -38,
		var2 = 11,
		tics = 2,
		nextstate = S_PLAY_SWID
}
states[S_PLAY_SWDG] = {
		sprite = SPR_PLAY,
		frame = SPR2_SWDG,
		var1 = -38,
		var2 = 11,
		tics = 32,
		nextstate = S_PLAY_SWID
}
states[S_PLAY_UWDG] = {
		sprite = SPR_PLAY,
		frame = SPR2_SWDG,
		var1 = -38,
		var2 = 11,
		tics = 350,
		nextstate = S_PLAY_FALL
}
states[S_PLAY_SWJP] = {
		sprite = SPR_PLAY,
		frame = SPR2_SWJP|A,
		tics = 7,
		nextstate = S_PLAY_SWID
}
states[S_PLAY_SWID] = {
		sprite = SPR_PLAY,
		frame = SPR2_SWID,
		var1 = -38,
		var2 = 11,
		tics = -1,
		
}
states[S_PLAY_SWIM] = {
        sprite = SPR_PLAY,
        frame = SPR2_SWIM|A,
        tics = -1,
}
states[S_PLAY_SWDR] = {
        sprite = SPR_PLAY,
        frame = SPR2_SWDR|A,
        tics = -1,
}
states[S_PLAY_KFAL] = {
		sprite = SPR_PLAY,
		frame = SPR2_BONK,
		var1 = -38,
		var2 = 11,
		tics = 7,
		nextstate = S_PLAY_FALL
}
states[S_PLAY_WPCH] = {
		sprite = SPR_PLAY,
		frame = SPR2_SGWP,
		var1 = -38,
		var2 = 11,
		tics = 14,
		nextstate = S_PLAY_FALL
}
states[S_PLAY_WKCK] = {
		sprite = SPR_PLAY,
		frame = SPR2_SGWJ,
		var1 = -38,
		var2 = 11,
		tics = -1,
}

local lngStates = {S_PLAY_LNGE, S_PLAY_LGST, S_PLAY_LGFL}
local superTheme = {
	["_super"] = "sgsuper",
}

local function getAnalogAngle(player)
	if (player.pflags & PF_ANALOGMODE)
	and (cmd.forwardmove ~= 0 or cmd.sidemove ~= 0)
		local tempangle
		tempangle = (cmd.angleturn*16)
		
		return tempangle
	end
end

local function mobj2DCheck(mobj)
	local var = ((mobj.flags2 & MF2_TWOD) or twodlevel)
	return var
end

local function getRefAngle(angle)
	local var = 0
		if angle <= 90
			var = angle
		elseif angle <= 180
			var = 180-angle
		elseif angle <= 270
			var = angle-180
		elseif angle <= 360
			var = 360 - angle
		end
	return var
end



local function giveAngleDist(angle)
	local angResult = 0
	if angle <= 45 then
		angResult = angle
	elseif angle <= 90
		angResult = 90-angle
	elseif angle <=135
		angResult = angle-90
	elseif angle <= 180
		angResult = 180 - angle
	elseif angle <= 225
		angResult = angle - 180
	elseif angle <= 270
		angResult = 270 - angle
	elseif angle <= 315
		angResult = angle - 270
	elseif angle <= 360
		angResult = 360 - angle
	end
	return angResult
end

local function outputReflection(a1, a2)
	local refResult = 0
	if a1 <= 90
		refResult = (a1+(a2*2))
	elseif a1 <= 135
		refResult = (a1-(a2*2))
	elseif a1 <= 180
		refResult = (a1+(a2*2))
	elseif a1 <= 225
		refResult = (a1-(a2*2))
	elseif a1 <= 270
		refResult = (a1+(a2*2))
	elseif a1 <= 315
		refResult = (a1-(a2*2))
	elseif a1 <= 360
		refResult = (a1+(a2*2))
	end
	return refResult
end

local function checkAxis2D(mo)
	if axis2d then
		local var = (mo.currentaxis ~= nil)
		return var
	else
		return false
	end
end

local function CanCrouch(player)
	local var = player.pflags & (PF_SLIDING|PF_SPINNING)
		or player.exiting
		or P_PlayerInPain(player)
		or player.powers[pw_carry]
		or player.playerstate == PST_DEAD
		or player.pflags & PF_STASIS 
		or player.pflags & PF_FULLSTASIS
		or player.mo.state == S_PLAY_SPRING
		or P_IsObjectInGoop(player.mo)
	return not var
end

local function DoJumpSpecial(p)
	local var = (p.pflags & (PF_SLIDING))
		or p.exiting
		or P_PlayerInPain(p)
		or p.powers[pw_carry]
		or p.playerstate == PST_DEAD
		or p.pflags & PF_STASIS 
		or p.pflags & PF_FULLSTASIS
		or p.wallHit == true
		or p.pflags & PF_THOKKED
		or p.mo.state == S_PLAY_SPRING
		or (p.mo.state == S_PLAY_FALL and p.hitSpring == true)
		or p.marioGPound ~= 0
		or p.carryState ~= 0
		or (p.ccTrCount > -1)
		or p.hitHoriz == true
		or p.lungeKick == true
		or (p.cantrick == true) --xommentum check so the epic funny doesn't break
		or p.wallBuffer ~= 0
		or p.slideJump ~= 0
		or p.gpJump ~= 0
		or (p.pflags & PF_JUMPDOWN) ~= 0
		or p.shieldUsed ~= false
	return not var
end

local function canKick(p)
	local var = (p.pflags & (PF_SLIDING))
		or p.wallHit ~= false
		or (P_IsObjectOnGround(p.mo) == true)
		or p.playerstate == PST_DEAD
		or p.lineCollide ~= true
		or ((lines[p.lastlinehit].flags & ML_NOCLIMB) ~= 0)
		or (p.speed/FRACUNIT) <= 12
		or ((((AngleFixed(p.mo.angle)/FRACUNIT) > (p.ranAngle2/FRACUNIT)) and ((AngleFixed(p.mo.angle)/FRACUNIT) < (p.ranAngle1/FRACUNIT)) and p.firstJump ~= true) or (p.firstJump ~= false))
		or (((p.linesector.floorheight) < (p.mo.z)) or (((p.linesector.floorheight) >= (p.mo.z)) and p.linesector.ceilingpic == "F_SKY1"))
	return not var
end


local function PlayerTransforming(p)
	local var = false
	if p.mo.state == 46 
	or p.mo.state == 47 
	or p.mo.state == 48 
	or p.mo.state == 49 
	or p.mo.state == 50 
	or p.mo.state == 51
		var = true
	end
	return var
end

local function inRaceCountdown()
	local var = false
	if ((gametyperules & GTR_RACE) and (leveltime < 4*TICRATE))
		var = true
	end
	return var
end

local function doLungeJump(p)
	if (p.pflags & PF_THOKKED) == 0 --thokked check so the game doesn't do supermanning
	and p.superman == false
		p.pflags = $|PF_THOKKED
	end
	if p.speed < p.normalspeed
		if checkAxis2D(p.mo)
			if p.mo.isfacingleft
				P_InstaThrust(p.mo, p.axisAngle-ANGLE_90, (p.normalspeed));
			else
				P_InstaThrust(p.mo, p.axisAngle+ANGLE_90, (p.normalspeed));
			end
		else
			P_InstaThrust(p.mo, p.drawangle, (p.normalspeed));
		end
	else
		P_InstaThrust(p.mo, p.drawangle, (p.speed+(p.normalspeed/3)));
	end
end

local function CanPound(p)
	local var = false
	if (p.mo.floorrover)
	and ((p.mo.floorrover.flags & FF_STRONGBUST) or (p.mo.floorrover.flags & FF_BUSTUP))
	and (P_IsObjectOnGround(p.mo))
		var = true
	end
	return var
end

local function PlayerWallCheck(p, angle)
	local wallBoolean = true
	local platx = P_ReturnThrustX(p.mo, angle, p.mo.radius + FixedMul(16*FRACUNIT, p.mo.scale));
	local platy = P_ReturnThrustY(p.mo, angle, p.mo.radius + FixedMul(16*FRACUNIT, p.mo.scale));
	local glidesector = R_PointInSubsector(p.mo.x + platx, p.mo.y + platy).sector;
	
	if glidesector.valid
		if ((glidesector.floorheight < p.mo.z) and glidesector.ceilingpic == "F_SKY1")
			wallBoolean = false
		end
	end
	return wallBoolean
end

local function doWallKick(p)
	P_InstaThrust(p.mo,p.kickAngle,2*FRACUNIT)
	if p.lungeKick == true
	and p.lungeKickVoice == false
		S_StartSound(p.mo, sfx_sglwk)
		p.lungeKickVoice = true
	else
		S_StartSound(p.mo, sfx_sgjm3)
	end
	p.mo.state = S_PLAY_WKCK
	p.firstJump = false
	if (p.pflags & PF_SPINNING)
		p.pflags = p.pflags & ~PF_SPINNING
	end
	p.mo.angle = p.kickAngle
	p.drawangle = p.kickAngle
	if p.lungeImpact ~= true
		P_InstaThrust(p.mo,p.kickAngle,(p.bpSpd/2))
		//p.mo.momx = p.bpMoX/2
		//p.mo.momy = p.bpMoY/2
	else
		P_InstaThrust(p.mo,p.kickAngle,((p.bpSpd/2)+(p.bpSpd/4)))
		//p.mo.momx = p.lgMoX+(p.lgMoX/4)
		//p.mo.momy = p.lgMoY+(p.lgMoY/4)
	end
	if P_MobjFlip(p.mo) > 0
		p.mo.momz = 12*FRACUNIT
	else
		p.mo.momz = -12*FRACUNIT
	end
				
	p.wallBuffer = 0
	p.wJumpHit = true
	p.wallHit = false
end

local function SGISwimHandler(p)
	if (p.pflags & PF_SLIDING) then p.swimming = false return end
	if p.powers[pw_carry] then p.swimming = false return end
	if P_PlayerInPain(p)
	and p.mo.state ~= S_PLAY_SWDG
		p.swDrill = false
		S_StartSound(p.mo, sfx_sgswd)
		p.mo.state = S_PLAY_SWDG
	end
	if p.swJpAnim == true
	and p.mo.state == S_PLAY_SWJP
	and p.swJpFrame < 6
		p.mo.state = S_PLAY_SWJP
		if P_MobjFlip(p.mo) > 0
			p.mo.momz = 9*FRACUNIT
		else
			p.mo.momz = -9*FRACUNIT
		end
		p.swJpFrame = $1+1
	else
		p.swJpAnim = false
		p.swJpFrame = 0
	end
	--swim drill
	if p.swDrill == true
		p.mo.momz = 0
		if not (p.pflags & PF_SPINNING)
			p.pflags = $|PF_SPINNING
		end
		
		if ((p.pflags & PF_DIRECTIONCHAR) ~= 0)
			if not (mobj2DCheck(p.mo) or checkAxis2D(p.mo))
				p.drawangle = p.swAngLock
				p.mo.momx = ((p.swimSpeed+6)*cos(p.drawangle))+(p.cmomx)
				p.mo.momy = ((p.swimSpeed+6)*sin(p.drawangle))+(p.cmomy)
			else
				if checkAxis2D(p.mo)
					if p.axisLock == 0
						p.drillAngle = p.axisAngle-ANGLE_90
					else
						p.drillAngle = p.axisAngle+ANGLE_90
					end
					p.drawangle = p.drillAngle
					p.mo.momx = ((p.swimSpeed+6)*cos(p.drillAngle))+(p.cmomx)
					p.mo.momy = ((p.swimSpeed+6)*sin(p.drillAngle))+(p.cmomy)
					//p.swimSpeed = $1+6
				else
					p.drawangle = p.swAngLock
					p.mo.momx = ((p.swimSpeed+6)*cos(p.drawangle))+(p.cmomx)
					p.mo.momy = ((p.swimSpeed+6)*sin(p.drawangle))+(p.cmomy)
					//p.swimSpeed = $1+(((p.normalspeed/FRACUNIT)/2)+6)
				end
			end
		else
			if checkAxis2D(p.mo)
				if p.axisLock == 0
					p.drillAngle = p.axisAngle-ANGLE_90
				else
					p.drillAngle = p.axisAngle+ANGLE_90
				end
				p.drawangle = p.drillAngle
				p.mo.momx = ((p.swimSpeed+6)*cos(p.drillAngle))+(p.cmomx)
				p.mo.momy = ((p.swimSpeed+6)*sin(p.drillAngle))+(p.cmomy)
				//p.swimSpeed = $1+6
			else
				p.mo.angle = p.swAngLock
				p.mo.momx = ((p.swimSpeed+6)*cos(p.mo.angle))+(p.cmomx)
				p.mo.momy = ((p.swimSpeed+6)*sin(p.mo.angle))+(p.cmomy)
				//p.swimSpeed = $1+(((p.normalspeed/FRACUNIT)/2)+6)
			end
		end
		local rng = (P_RandomRange(-45,45)*FRACUNIT)
		local rng2 = (P_RandomRange(-45,45)*FRACUNIT)
		local bubble = P_SpawnMobj(p.mo.x+rng, p.mo.y+rng, p.mo.z+rng2, MT_MEDIUMBUBBLE)
		if not checkAxis2D(p.mo)
			p.drawangle = p.swAngLock
		end
		
		p.swDrDelay = $1+1
		p.swDrlStopDelay = $1+1
		if p.swDrDelay > 2
			p.mo.state = S_PLAY_SWDR
			p.swDrDelay = 0
		end
		if p.swDrlStopDelay > 24
			p.swDrDelay = 0
			p.mo.state = S_PLAY_SWID
			if p.swimSpeed < (p.normalspeed/FRACUNIT)+((p.normalspeed/FRACUNIT)/3)
				p.swimSpeed = p.swimSpeed+6
			end
			p.swDrill = false
		end
	else
		if not (p.pflags & PF_NOJUMPDAMAGE)
			p.pflags = $|PF_NOJUMPDAMAGE
		end
		if (p.pflags & PF_SPINNING)
			p.pflags = p.pflags & ~PF_SPINNING
		end
		if (p.pflags & PF_STASIS)
			p.pflags = p.pflags & ~PF_STASIS
		end
		p.swDrlStopDelay = 0
		
	end
	if p.mo.state ~= S_PLAY_SWIM
	and p.mo.state ~= S_PLAY_SWJP
		if P_MobjFlip(p.mo) > 0
			if p.mo.momz < -15*FRACUNIT
				p.mo.momz = -15*FRACUNIT
			end
		else
			if p.mo.momz > 15*FRACUNIT
				p.mo.momz = 15*FRACUNIT
			end
		end
		if p.cmd.forwardmove ~= 0 or p.cmd.sidemove ~= 0
			if P_PlayerInPain(p) ~= true
			and p.mo.state ~= S_PLAY_SWDG
			and p.swDrill ~= true
				p.mo.state = S_PLAY_SWIM
			end
		end
	else
		
		if p.mo.state == S_PLAY_SWIM
			if P_MobjFlip(p.mo) > 0
				if p.mo.momz < 0
					p.mo.momz = 0
				end
			else
				if p.mo.momz > 0
					p.mo.momz = 0
				end
			end
			if p.cmd.forwardmove ~= 0 or p.cmd.sidemove ~= 0
				//P_InstaThrust(p.mo, p.drawangle, 5*FRACUNIT);
				if p.setSwSpeed ~= true
					p.swimSpeed = (p.speed/FRACUNIT)
					p.setSwSpeed = true
				end
				if ((p.pflags & PF_DIRECTIONCHAR) ~= 0)
					p.mo.momx = ((p.swimSpeed)*cos(p.drawangle))+(p.cmomx)
					p.mo.momy = ((p.swimSpeed)*sin(p.drawangle))+(p.cmomy)
				else
					if (p.pflags & PF_ANALOGMODE)
						if not (mobj2DCheck(p.mo) or checkAxis2D(p.mo))
							if p.cmd.forwardmove ~= 0 or p.cmd.sidemove ~= 0
								p.mo.momx = ((p.swimSpeed)*cos(p.mo.angle)+((p.cmd.sidemove/5)*cos(p.mo.angle-ANGLE_90)))+(p.cmomx)
								p.mo.momy = ((p.swimSpeed)*sin(p.mo.angle)+((p.cmd.sidemove/5)*sin(p.mo.angle-ANGLE_90)))+(p.cmomy)
							end
						end
					else
						if not (mobj2DCheck(p.mo) or checkAxis2D(p.mo))
							if p.cmd.forwardmove ~= 0 or p.cmd.sidemove ~= 0
								p.mo.momx = ((p.swimSpeed)*cos(p.mo.angle)+((p.cmd.sidemove/5)*cos(p.mo.angle-ANGLE_90)))+(p.cmomx)
								p.mo.momy = ((p.swimSpeed)*sin(p.mo.angle)+((p.cmd.sidemove/5)*sin(p.mo.angle-ANGLE_90)))+(p.cmomy)
							end
						else
							//p.mo.momx = ((p.swimSpeed)*cos(p.drawangle))+(p.cmomx)
							//p.mo.momy = ((p.swimSpeed)*sin(p.drawangle))+(p.cmomy)
						end
					end
				end
				p.swimDelay = $1+1
				if ((p.pflags & PF_DIRECTIONCHAR) ~= 0)
					if p.swimSpeed < 18
						p.swimSpeed = $1+(p.swimSlowBuffer/2)
						p.swimSlowBuffer = $1+1
					else
						if p.swimSpeed > 18
							p.swimSpeed = $1-(p.swimSlowBuffer/2)
							p.swimSlowBuffer = $1+1
						end
					end
				else
					if p.swimSpeed < (p.cmd.forwardmove/4)
						p.swimSpeed = $1+(p.swimSlowBuffer/2)
						p.swimSlowBuffer = $1+1
					else
						if p.swimSpeed > (p.cmd.forwardmove/4)
							p.swimSpeed = $1-(p.swimSlowBuffer/2)
							p.swimSlowBuffer = $1+1
						end
					end
				end
				if p.swimSlowBuffer > 2
					p.swimSlowBuffer = 0
				end
			else
				p.swimDelay = 0
				p.swimFrame = 0
				p.swimSpeed = 0
				p.setSwSpeed = false
				p.mo.state = S_PLAY_SWID
			end
			if p.swimDelay >= 5
				p.mo.state = S_PLAY_SWIM
				if p.swimFrame <= 5
					p.swimFrame = $1+1
				else
					p.swimFrame = 0
				end
				p.swimDelay = 0
			end
			--swimming sound
			
			if (p.swimFrame == 2) or (p.swimFrame == 5)
				if (p.swimSound ~= true)
					S_StartSound(p.mo, sfx_sgswm)
					p.swimSound = true
				end
			else
				p.swimSound = false
			end
		end
		if p.mo.state == S_PLAY_SWDG
			if p.swimSpeed > 0
				p.swimSpeed = $1-1
			end
		end
	end
end

SGIMReset = function(p)
	p.superman = false --if true, purposefully re-enables the infamous Superman Bug that plagued the development of 1.2
	p.mariogrounded = 0 -- How long have we been on the ground? Updates every ThinkFrame hook
	p.mariocrouching = 0 -- Are we crouching by holding B?
	p.marioGPound = 0
	p.marioCheck = 0
	--wall jump vars (90% is unused!!!)
	p.lineRef = 0
	p.moveAngle = 0
	p.ccTrCount = -1 --get the number of performed tricks from ChrispyChars; necessary for supermanning not to happen
	p.angle1 = 0
	p.angle2 = 0
	p.angle3 = 0
	p.angle4 = 0
	p.impactX = 0
	p.impactY = 0
	p.hitLine = nil
	p.lineCollide = false
	p.inKickRange = false
	p.firstJump = false
	p.linePointer = 0
	p.linesector = (R_PointInSubsector(p.mo.x, p.mo.y).sector)
	p.wallSector = 0
	p.lungeImpact = false
	p.lungeKickVoice = false
	p.hasFFloor = false
	p.highestFFloor = nil
	p.lowestFFloor = nil
	p.lgMoX = 0
	p.lgMoY = 0
	p.bpMoX = 0
	p.bpMoY = 0
	p.bpSpd = 0
	p.platx = 0
	p.platy = 0
	p.reflectAngle = 0
	p.fullReflect = 0
	p.wallReverse = 0 -- 0 = false, 1 = true
	p.playerReverse = 0
	p.wallHit = false
	p.wJumpHit = false
	p.wallBuffer = 0 -- when this goes over 5, reset it
	p.lungeKick = false
	p.impactAngle = 0;
	--end wall jump vars
	p.SGIGravity = 0 -- 0 = Normal, 1 = Reverse
	p.SGIFOFSpecial = 0
	p.SGIGroundSpecial = 0
	p.linedefAngle = 0
	p.linedefPerpendicular = 0
	p.ranAngle1 = 0 -- range angle
	p.ranAngle2 = 0
	p.busted = false
	p.rkynLunged = false
	p.wasRiding = false
	p.hitBooster = false
	p.boostBuffer = 0
	p.wasCrouching = false
	p.usedElemental = false
	p.shieldUsed = false
	p.sprVoice = false
	p.spinHit = false
	p.hitHoriz = false
	p.horizHit2 = false
	p.pressSpecial = false
	p.landed = true
	p.jumped = true
	--swimming vars start HERE
	p.swimming = false
	p.swimUp = false
	p.swimJumpBuffer = 0
	p.swimSlowBuffer = 0
	p.swimDelay = 0
	p.swDrDelay = 0
	p.swimFrame = 0
	p.swimSpeed = 0
	p.swJpFrame = 0
	p.camAngle = 0
	p.swAngLock = 0 -- store angle for swim drill
	p.axisLock = 0 -- 0 is left, 1 is right
	p.swDrlStopDelay = 0
	p.drillAngle = 0
	p.setSwSpeed = false
	p.swJpAnim = false
	p.swimSound = false
	p.swDrill = false
	p.swDrBtn = false
	--swimming vars END here
	p.analogAngle = 0
	p.axisFlip = 0
	p.marioDrop = 0
	p.carryState = 0
	p.kickCarry = 0
	p.voiceRandom = 0
	p.prevState = nil
	p.prevDelay = 2
	p.prevMomX = 0
	p.prevMomY = 0
	p.metalMode = 0
	p.lungeTimer = 0
	p.poundDelay = 10
	p.poundX = 0
	p.poundY = 0
	p.poundZ = 0
	p.gpJump = 0
	p.slideDelay = 0
	p.wasSliding = false
	p.waterDamage = false
	p.slideJump = 0
	p.crawlDelay = 0
	p.hitSpring = false
	p.defaultHeight = 48
	p.crawlMove = false
	p.crawlCooldown = 5
	p.rollWindow = false
	p.rollDelay = 8
	p.sPoundWindow = false
	p.sPoundDelay = 8
	p.rollSpeed = 35
	p.rolling = false
	p.sgiLunge = false
	p.lungeTimer = 0
end



SGIJump = function(p)
	p.voiceRandom = P_RandomKey(6)+1
	S_StartSound(p.mo, jumpVoice[p.voiceRandom])
end

SGIHurt = function(p)
	p.voiceRandom = P_RandomKey(2)+1
	S_StartSound(p.mo, hurtVoice[p.voiceRandom])
end

SGISpring = function(p) --vocals for springboosting
	p.voiceRandom = P_RandomKey(3)+1
	S_StartSound(p.mo, springVoice[p.voiceRandom])
end

SGIPassive = function(p)
	p.marioCheck = 1
	local hitLine
	
	//print(inRaceCountdown())
	//print(p.pflags & PF_THOKKED)
	if p.mo.cc_tricks ~= nil
		if p.superman == false
			p.ccTrCount = p.mo.cc_tricks.count
		end
		
	end
	if p.powers[pw_pushing] > 0
		if p.lastlinehit ~= -1
			p.lineCollide = true
		end
	else
		p.lastlinehit = -1;
		if p.wallHit ~= true
			p.lineCollide = false
		end
	end
	//print(p.powers[pw_shield])
	//print(p.hitHoriz)
	--hitHoriz override prevention
	/*if p.hitHoriz == true
	and ((p.pflags & PF_STARTJUMP) or (P_IsObjectOnGround(p.mo)))
		p.hitHoriz = false
	end*/
	//print(((p.pflags & PF_STARTJUMP) or (P_IsObjectOnGround(p.mo))))
	/*if (p.ranAngle1 ~= p.ranAngle2)
		print("..PLAYER ANGLE..")
		print(AngleFixed(p.mo.angle)/FRACUNIT)
		if (((AngleFixed(p.mo.angle)/FRACUNIT) <= (p.ranAngle2/FRACUNIT)) and ((AngleFixed(p.mo.angle)/FRACUNIT) >= (p.ranAngle1/FRACUNIT)))
			p.inKickRange = true
		else
			if p.wallHit ~= true
				p.inKickRange = false
			end
		end
		print("..IN KICK RANGE?..")
		print(p.inKickRange)
	end*/
	if lines[p.lastlinehit] ~= nil
		//print(p.lastlinehit)
		
		if p.powers[pw_pushing] > 0
			p.linePointer = (P_PointOnLineSide(p.mo.x,p.mo.y,lines[p.lastlinehit].v1.x,lines[p.lastlinehit].v1.y,lines[p.lastlinehit].v2.x,lines[p.lastlinehit].v2.y))
			p.linedefAngle = R_PointToAngle2(lines[p.lastlinehit].v2.x,lines[p.lastlinehit].v2.y,lines[p.lastlinehit].v1.x,lines[p.lastlinehit].v1.y)
			p.linedefPerpendicular = AngleFixed(p.linedefAngle-ANGLE_90+(ANGLE_180*(p.linePointer)))
			p.ranAngle1 = p.linedefPerpendicular-(65*FRACUNIT)
			p.ranAngle2 = p.linedefPerpendicular+(65*FRACUNIT)
			if (lines[p.lastlinehit].backsector and not (P_PointOnLineSide(p.mo.x,p.mo.y,lines[p.lastlinehit].v1.x,lines[p.lastlinehit].v1.y,lines[p.lastlinehit].v2.x,lines[p.lastlinehit].v2.y)))
				p.linesector = lines[p.lastlinehit].backsector
			else
				p.linesector = lines[p.lastlinehit].frontsector
			end
			/*print("..LINE ANGLE..")
			print(AngleFixed(p.linedefAngle)/FRACUNIT)
			print("..LINE POINTER..")
			print(p.linePointer)
			print("..PERP. ANGLE..")
			print(p.linedefPerpendicular/FRACUNIT)
			print("..RANGE ANGLES..")
			print(p.ranAngle1/FRACUNIT)
			print(p.ranAngle2/FRACUNIT)*/
			p.hasFFloor = false
			//p.platx = P_ReturnThrustX(p.mo, (AngleFixed(p.linedefAngle)-(ANGLE_90)), p.mo.radius + FixedMul(8*FRACUNIT, p.mo.scale));
			//p.platy = P_ReturnThrustY(p.mo, (AngleFixed(p.linedefAngle)-(ANGLE_90)), p.mo.radius + FixedMul(8*FRACUNIT, p.mo.scale));
			p.platx = P_ReturnThrustX(p.mo, (p.mo.angle), p.mo.radius + FixedMul(8*FRACUNIT, p.mo.scale));
			p.platy = P_ReturnThrustY(p.mo, (p.mo.angle), p.mo.radius + FixedMul(8*FRACUNIT, p.mo.scale));
			p.wallSector = R_PointInSubsector(p.mo.x + p.platx, p.mo.y + p.platy).sector
			for ffloor in p.wallSector.ffloors()
				if p.hasFFloor ~= true
					p.hasFFloor = true
				end
				if p.highestFFloor == nil
				or ffloor.topheight > p.highestFFloor
					p.highestFFloor = ffloor.topheight
				end
				if p.lowestFFloor == nil
				or ffloor.bottomheight > p.lowestFFloor
					//if (ffloor.bottomheight ~= -18874368)
					p.lowestFFloor = ffloor.bottomheight
				end
			end
		end
		//print(p.linesector.floorheight)
		//print(p.linesector.ceilingpic)
		//print(p.mo.z)
		//print(AngleFixed(p.linedefAngle)/FRACUNIT)
		//print(p.linePointer)
		
		//print(p.wallSector)
		//print(p.highestFFloor)
		//print(p.hasFFloor)
		
		/*for ffloor in p.wallSector.ffloors()
			print("..FFLOOR..")
			print(ffloor.topheight)
		end*/
		//print("..linepointer garbage..")
		//print(p.linePointer)
		//print(p.mo.angle)
		//print((AngleFixed(p.linedefAngle)/FRACUNIT))
		//print((AngleFixed(p.linedefAngle)-(90*FRACUNIT))/FRACUNIT)
		//print("..............")
	end
	
	if p.speed > 3
		p.moveAngle = p.mo.angle
	end
	//print(p.kickCarry)
	//print(p.powers[pw_pushing])
	//print(p.lineCollide)
	--wallHit disabler for horizontal spring hits
	if (p.horizHit2 == true)
	and p.wallHit ~= false
		p.wallHit = false
		p.wallBuffer = 0
	end
	-- very hacky wallkick system incoming:
	if (p.pflags & PF_STARTJUMP)
		if p.firstJump == false
			p.firstJump = true
		end
	end
	if p.kickCarry > 0
		p.wallHit = false
	end
	if p.powers[pw_pushing] > 0
		if (p.pflags & PF_THOKKED)
		and (P_IsObjectOnGround(p.mo) ~= true)
			p.pflags = (p.pflags & ~PF_THOKKED)
		end
		if p.nightstime == 0
			if p.wallHit == false
			and p.playerstate ~= PST_DEAD
			and p.hitHoriz ~= true
			and p.kickCarry == 0
			and (P_IsObjectOnGround(p.mo) ~= true)
			and p.lineCollide == true
			and (p.speed/FRACUNIT) > 12
			and ((((AngleFixed(p.mo.angle)/FRACUNIT) <= (p.ranAngle2/FRACUNIT)) and ((AngleFixed(p.mo.angle)/FRACUNIT) >= (p.ranAngle1/FRACUNIT)) and p.firstJump == true) or (p.firstJump == false))
			and (((p.linesector.floorheight) >= (p.mo.z)) or (((p.linesector.floorheight) < (p.mo.z)) and p.linesector.ceilingpic ~= "F_SKY1"))
			or ((p.hasFFloor == true) and (p.highestFFloor >= (p.mo.z)))
				if (p.mo.state == S_PLAY_JUMP)
				and (p.pflags & ~PF_THOKKED)
				and p.kickCarry == 0
					if (p.powers[pw_super] == 0)
						S_StartSound(p.mo, sfx_sgwkc)
					else
						S_StartSound(p.mo, sfx_sgmwk)
					end
					DoSpinDashDust(p, p.mo.momz)
					p.mo.state = S_PLAY_WPCH
					p.impactX = p.mo.x
					p.impactY = p.mo.y
					p.impactAngle = p.mo.angle
					P_BounceMove(p.mo)
					p.bpSpd = p.speed
					p.bpMoX = p.mo.momx
					p.bpMoY = p.mo.momy
					p.kickAngle = R_PointToAngle2(p.impactX,p.impactY,p.mo.x,p.mo.y)
					p.mo.momx = 0
					p.mo.momy = 0
					p.mo.momz = 0
					p.pflags = $|PF_STASIS
					//P_TeleportMove(p.mo,(p.impactX+(400*(cos(p.kickAngle)))),(p.impactY+(400*(sin(p.kickAngle)))),p.mo.z)
					p.wallHit = true
				elseif (p.mo.state == S_PLAY_WKCK)
				and (p.pflags & ~PF_THOKKED)
				and p.kickCarry == 0
					if (p.powers[pw_super] == 0)
						S_StartSound(p.mo, sfx_sgwkc)
					else
						S_StartSound(p.mo, sfx_sgmwk)
					end
					DoSpinDashDust(p, p.mo.momz)
					p.mo.state = S_PLAY_WPCH
					p.impactX = p.mo.x
					p.impactY = p.mo.y
					p.impactAngle = p.mo.angle
					P_BounceMove(p.mo)
					p.mo.momx = 20
					p.mo.momy = 20
					p.kickAngle = R_PointToAngle2(p.impactX,p.impactY,p.mo.x,p.mo.y)
					p.mo.momx = 0
					p.mo.momy = 0
					p.mo.momz = 0
					//if p.lungeKick ~= true
						p.pflags = $|PF_STASIS
					//end
					//P_TeleportMove(p.mo,(p.impactX+(400*cos(p.kickAngle))),(p.impactY+(400*sin(p.kickAngle))),p.mo.z)
					p.wallHit = true
				elseif p.kickCarry == 0
					for i = 1, #lngStates
						if p.mo.state == lngStates[i]
							if (p.powers[pw_super] == 0)
								S_StartSound(p.mo, sfx_sgwkc)
							else
								S_StartSound(p.mo, sfx_sgmwk)
							end
							DoSpinDashDust(p, p.mo.momz)
							p.mo.state = S_PLAY_WPCH
							p.impactX = p.mo.x
							p.impactY = p.mo.y
							p.impactAngle = p.mo.angle
							P_BounceMove(p.mo)
							p.bpSpd = p.speed
							p.lgMoX = p.mo.momx
							p.lgMoY = p.mo.momy
							p.bpMoX = p.mo.momx
							p.bpMoY = p.mo.momy
							p.kickAngle = R_PointToAngle2(p.impactX,p.impactY,p.mo.x,p.mo.y)
							p.mo.momx = 0
							p.mo.momy = 0
							p.mo.momz = 0
							//p.mo.state = S_PLAY_WPCH
							p.pflags = $|PF_STASIS
							p.lungeKick = true
							p.lungeImpact = true
							p.wallHit = true
							break
						end
					end
				end
			end
		end
		if p.lineCollide == true
		and ((p.linesector.floorheight) < (p.mo.z)) 
		and (p.linesector.ceilingpic == "F_SKY1")
		and (p.highestFFloor ~= nil)
		and ((p.highestFFloor < (p.mo.z)))
		and (P_IsObjectOnGround(p.mo) ~= true)
			S_StartSound(p.mo, sfx_sgiwk)
		end
	end
	//print(p.mo.z)
	/*print((p.lowestFFloor ~= nil) and (p.mo.z < p.lowestFFloor))
	if (p.hasFFloor == true) -- scrapped; doing this proved to be really fucking frustrating
	and (p.lowestFFloor ~= nil) 
	and(p.mo.z < p.lowestFFloor)
		if p.wallHit ~= false
			if (p.mo.state == S_PLAY_WPCH)
				p.mo.state = S_PLAY_FALL
				if (p.pflags & PF_STASIS)
					p.pflags = p.pflags & ~PF_STASIS
				end
			end
			p.wallHit = false
		end
	end*/
	if p.wallHit ~= false
		p.wallBuffer = $1 + 1
		p.drawangle = p.impactAngle
		if ((p.pflags & PF_JUMPDOWN) and p.wJumpHit == false)
			doWallKick(p)
			
		end
		if (p.wallBuffer > 7) 
		and (p.lungeKick == true)
			S_StartSound(p.mo, sfx_sgkfl)
			p.mo.momx = p.bpMoX/4
			p.mo.momy = p.bpMoY/4
			p.lungeKick = false
			p.mo.state = S_PLAY_KFAL
			p.wallBuffer = 0
			p.wallHit = false
		end
	end
	
	//print(p.hitSpring)
	if p.mo.state == S_PLAY_FALL
		if p.wallHit ~= false
			p.wallHit = false
		end
	end
	if not (p.cmd.buttons & BT_JUMP)
		if p.wJumpHit == true
			p.wJumpHit = false
		end
	else
		if p.wJumpHit ~= true
			p.wJumpHit = true
		end
	end
	-- reset kick buffers if bing bing man is ground pounding or swimming
	if p.marioGPound ~= 0
	or p.swimming == true
		p.wallBuffer = 0
		p.wallHit = false
	end
	//p.analogAngle = R_PointToAngle2(0, 0, p.cmd.forwardmove*FRACUNIT, (p.cmd.sidemove*FRACUNIT)*(-1));
	--check immediately if the player should be considered underwater
	if p.powers[pw_justsprung]
	and p.hitHoriz == false
		p.hitSpring = true
	end
	--hardcode the player's state to be a wall perch
	if p.lungeKick == true
		if p.wallHit == true
			p.mo.state = S_PLAY_WPCH
		elseif ((P_IsObjectOnGround(p.mo) ~= true) and (P_PlayerInPain(p) ~= true))
			p.mo.state = S_PLAY_WKCK
		end
	end
	--booster fix
	if p.hitBooster == true
		p.boostBuffer = $1+1
		if p.mo.state == S_PLAY_ROLL
		and not (p.pflags & PF_SPINNING)
			p.mo.state = S_PLAY_WALK
			p.hitBooster = false
		end
		if p.boostBuffer > 3
			p.hitBooster = false
		end
	end
	if p.hitSpring == true
		if p.sgiLunge == true
			if (p.pflags & PF_SPINNING)
				p.pflags = p.pflags & ~PF_SPINNING
			end
			p.sgiLunge = false
		end
	end
	--goop fix
	if p.sgiLunge == true
	and P_IsObjectInGoop(p.mo)
		if (p.pflags & PF_SPINNING)
			p.pflags = p.pflags & ~PF_SPINNING
		end
	end
	if (p.mo.eflags & MFE_UNDERWATER)
	and (p.powers[pw_super] == 0)
		p.underwaterCheck = true
	else
		if p.swimming == true
			p.mo.state = S_PLAY_FALL
			p.swDrill = false
			p.swDrBtn = false
			if (p.pflags & PF_STASIS)
				p.pflags = p.pflags & ~PF_STASIS
			end
			p.swimming = false
		end
		p.underwaterCheck = false
	end
	--swim code
	if p.swimming == true
		p.charflags = $|SF_NOSHIELDABILITY
		if p.sgiLunge ~= false
			if (p.pflags & PF_SPINNING)
				p.pflags = p.pflags & ~PF_SPINNING
			end
			p.sgiLunge = false
		end
		if P_IsObjectOnGround(p.mo) then
			p.swDrill = false
			p.swimming = false
			p.swimSound = false
		else
			if p.playerstate ~= PST_DEAD
				SGISwimHandler(p)
			end
		end
		if p.powers[pw_justsprung]
		and p.hitHoriz == false
			p.hitSpring = true
			p.mo.state = S_PLAY_SPRING
		end
		if p.mo.state == S_PLAY_SPRING
		or (p.powers[pw_justsprung] and p.hitHoriz == false)
			p.swDrill = false
			p.swimming = false
			p.swimSound = false
		end
	end
	if p.swimming ~=  true
		if (p.charflags & SF_NOSHIELDABILITY)
			p.charflags = $ & ~SF_NOSHIELDABILITY
		end
	end
	--force drill double tap
	if not (p.pflags & PF_USEDOWN)
		p.swDrBtn = false
	end
	--necessary for lunge jump
	if (p.pflags & PF_SLIDING)
		p.wasSliding = true
	end
	--play funny "here we go!!!!" noise
	if p.tfmVoice ~= true
	and PlayerTransforming(p) == true
		S_StartSound(p.mo, sfx_sgtfm)
		p.tfmVoice = true
	end
	--reset so the voice clip always plays
	if p.powers[pw_super] == 0
		p.tfmVoice = false
	end
	--voice shenanigans start here
	if p.jmpVoice ~= true
		if p.mo.state == S_PLAY_JUMP
			SGIJump(p)
			p.jmpVoice = true
		end
	end
	--remove sgiLunge on player pain state
	if P_PlayerInPain(p) == true
		if p.sgiLunge == true
			if (p.pflags & PF_SPINNING)
				p.pflags = p.pflags & ~PF_SPINNING
			end
			p.sgiLunge = false
		end
	end
	--voice shenanigans end here
	if p.powers[pw_carry] ~= 0
		p.shieldUsed = false --reset shieldUsed to false, otherwise there will be much pissing
		p.kickCarry = p.powers[pw_carry] --dupe for the sake of bugfixing
		p.carryState = p.powers[pw_carry] --copy carry state so the double tap actually works kjfgfkjghkjdf
	end
	//local particle = P_SpawnMobj(p.mo.x+((20*FRACUNIT)*cos(p.analogAngle+p.prevAngle)), p.mo.y+((20*FRACUNIT)*sin(p.analogAngle+p.prevAngle)), p.mo.z,  MT_SPINDUST)
	//print(p.pflags & PF_SPINNING) --IT WORKS
	--this journey is finally over
	if p.hrtVoice ~= true
		if P_PlayerInPain(p) == true
			SGIHurt(p)
			p.hrtVoice = true
		end
	end
	--set underwater and space suffocation timers to max to prevent drowning while metal/super
	if p.powers[pw_super] ~= 0
		p.metalMode = $1+1
		p.powers[pw_underwater] = 1050
		p.powers[pw_spacetime] = 1050
	end
	--reset player damage voice if no longer in pain
	if P_PlayerInPain(p) ~= true
		p.hrtVoice = false
	end
	--unused code
	if p.mo.state ~= p.prevState
	and p.prevDelay <= 0
		p.prevState = p.mo.state
	end
	--also unused code (I think)
	if p.prevDelay > 0
		p.prevDelay = $1-1
	end
	
	if p.mo.state == S_PLAY_RIDE
		p.wasRiding = true
	end
	if p.mo.state == S_PLAY_WALK
	or p.mo.state == S_PLAY_STND
		p.wasCrouching = false
	end
	
	-- Initialize S_SKIN values, because other functions may change these.
	p.normalspeed = skins.sgimario.normalspeed
	p.thrustfactor = 5
	if p.sgiLunge == true
	and not P_IsObjectInGoop(p.mo)
	and not (p.pflags & PF_SPINNING)
			p.pflags = $|PF_SPINNING
	end
	
	if P_IsObjectOnGround(p.mo) 
		if p.mo.state == S_PLAY_WPCH
			p.wallHit = false
			if (p.pflags & PF_STASIS)
				p.pflags = p.pflags & ~PF_STASIS
			end
			if (p.pflags & PF_STARTJUMP) --somehow resetting the state to stand can break how the game handles these?
				p.pflags = p.pflags & ~PF_STARTJUMP
			end
			if (p.pflags & PF_JUMPED)
				p.pflags = p.pflags & ~PF_JUMPED
			end
			p.mo.state = S_PLAY_STND
		end
	end
	
	if p.mo.state == S_PLAY_KFAL
		if (p.pflags & PF_STASIS)
			p.pflags = p.pflags & ~PF_STASIS
		end
	end
	if ((p.pflags & PF_STARTJUMP))
		p.horizHit2 = false
	end
	if P_IsObjectOnGround(p.mo) then
		p.hitSpring = false
		p.horizHit2 = false
		p.shieldUsed = false
		p.wallHit = false
		p.firstJump = false
		p.wallBuffer = 0
		p.wJumpHit = false
		p.lungeImpact = false
		p.lungeKickVoice = false
		p.lungeKick = false
		p.kickCarry = 0
		p.mariogrounded = $1+1
		p.lungeTimer = 0
		p.gpJump = 0
		if p.sgiLunge ~= false
			if (p.pflags & PF_SPINNING)
				p.pflags = p.pflags & ~PF_SPINNING
			end
			p.sgiLunge = false
		end
		if p.landed ~= true
			
			if leveltime >= 5
			and p.marioGPound == 0
			and p.nightstime == 0
				if p.powers[pw_super] == 0
					S_StartSound(p.mo, sfx_sglnd)
				else
					S_StartSound(p.mo, sfx_sgmld)
				end
			end
			p.landed = true
		end
		p.wasRiding = false
		p.sPoundDelay = 8
		if p.marioGPound then
			if p.pflags & (PF_SLIDING|PF_SPINNING) then 
				p.marioGPound = 0
				p.mo.state = S_PLAY_ROLL
				return
			end
			if p.mo.state ~= S_PLAY_GPLD
				DoSpinDashDust(p, p.normalspeed)
				S_StartSound(p.mo, sfx_sgpnd)
				p.mo.state = S_PLAY_GPLD
			end
		end
		if p.powers[pw_shield] == 3073 and p.usedElemental == true
			p.mo.state = S_PLAY_ROLL
			p.pflags = $|PF_SPINNING
			p.rolling = true
			SGIBlockBust(p)
			if p.busted == false
				/*P_InstaThrust(p.mo, p.drawangle, (66*FRACUNIT))
				DoSpinDashDust(p, p.normalspeed)
				S_StartSound(p.mo, sfx_frerol)
				S_StartSound(p.mo, sfx_sgrls)
				DoSpinDashDust(p, p.normalspeed)
				p.rollDelay = 8*/
			end
			p.usedElemental = false
		end
		p.jmpVoice = false
		p.jumpfactor = skins.sgimario.jumpfactor
	else
		if p.mariogrounded ~= 0
		and p.deadtimer == 0
		and p.mo.state == S_PLAY_JUMP
			if p.powers[pw_super] == 0
				S_StartSound(p.mo, sfx_sgjmp)
			else
				S_StartSound(p.mo, sfx_sgmjm)
			end
		end
		p.lungeTimer = $1+1
		p.mariogrounded = 0
		p.landed = false
	end
	
	if p.mo.state == S_PLAY_SPRING
		if p.marioGPound
			p.mo.momx = $1+($1/3)
			p.mo.momy = $1+($1/3)
			p.mo.momz = $1+($1/3)
			S_StartSound(p.mo, sfx_sgspg)
			SGISpring(p)
		end
		p.marioGPound = 0
	end
	
	if P_PlayerInPain(p) or p.deadtimer then
		SGIMReset(p)
	elseif p.mariocrouching then
		SGICrouching(p)
	end
	
	if p.mo.state == S_PLAY_DUCK
	or p.mo.state == S_PLAY_CRSD
	or p.mo.state == S_PLAY_CRMV
		p.height = 32*FRACUNIT
	else
		p.height = 48*FRACUNIT
	end
	
	if p.sPoundWindow == true
		if p.sPoundDelay > 0
			p.sPoundDelay = $1-1
		else
			p.sPoundWindow = false
		end
	end
	
	if p.powers[pw_carry]
		p.sgiLunge = false
	end
	
	if p.marioGPound then
		if p.playerstate == PST_DEAD
			if S_SoundPlaying(p.mo, sfx_sgpnd)
				S_StopSoundByID(p.mo, sfx_sgpnd)
			end
			p.mo.state = S_PLAY_DEAD
			p.marioGPound = 0
		end
		p.mo.momx = p.cmomx
		p.mo.momy = p.cmomy
		SGIBlockBust(p)
		if not CanCrouch(p)
			p.marioGPound = 0
		end
		if p.mo.state == S_PLAY_GPST
			p.mo.z = p.poundZ
			p.mo.momz = 0
		else
			if p.mo.state == S_PLAY_GRPD
				if P_MobjFlip(p.mo) > 0
					if p.mo.momz >= 0
						if p.SGIGroundSpecial == 15 or p.SGIFOFSpecial == 15 then 
							p.mo.state = S_PLAY_JUMP
							p.marioGPound = 0
						end
						p.mo.momz = p.mo.momz*(-1)
					end
				else
					if p.mo.momz <= 0
						if p.SGIGroundSpecial == 15 or p.SGIFOFSpecial == 15 then
							p.mo.state = S_PLAY_JUMP
							p.marioGPound = 0
						end
						p.mo.momz = p.mo.momz*(-1)
					end
				end
			end
		end
		if p.mo.state ~= S_PLAY_GRPD
		and p.mo.state ~= S_PLAY_GPST
			if p.poundDelay > 0
				p.poundDelay = $1-1
			else
				p.marioGPound = 0
				p.mo.state = S_PLAY_WALK
				p.busted = false
				p.poundDelay = 14
			end
		end
	else
		p.busted = false
	end
	
	if p.mariocrouching then
		p.crawlCooldown = $1-1
		p.crawlDelay = $1+1
	else
		p.crawlCooldown = 45
		if p.rollWindow == true then
			p.rollDelay = $1 - 1
			if p.rollDelay <= 0
				p.rollDelay = 8
				p.rollWindow = false
			else
				p.rollWindow = true
			end
		end
	end
	
	if p.rolling == true
		if p.speed <= 2 and p.marioGPound
			if (p.pflags & PF_ANALOGMODE)
			and not (p.pflags & PF_DIRECTIONCHAR)
				p.drawangle = p.mo.angle
			elseif not (p.pflags & PF_ANALOGMODE)
				p.drawangle = p.mo.angle
			end
			P_InstaThrust(p.mo, p.drawangle, p.rollSpeed*FRACUNIT)
			p.rollSpeed = $1-2
			p.marioGPound = 0
		end
	else
		p.rollSpeed = 64
	end
	
	if p.rollSpeed <= 0
		p.rolling = false
		p.rollSpeed = 35
	end
	
	if not (p.pflags & PF_SPINNING) then
		p.rolling = false
	end
	
	p.SGIGroundSpecial = p.mo.subsector.sector.special
	local rover = (p.mo.eflags & MFE_VERTICALFLIP) and p.mo.ceilingrover or p.mo.floorrover
	if (rover and rover.valid) 
	and(rover.flags & FF_EXISTS) then 
		p.SGIFOFSpecial = rover.sector.special
	end
	
	//print(p.powers[pw_shield])
end
SGICrouchBegin = function(p)
	-- Hold B to crouch.
	if p.swimming == true then return false end
	if not (p.pflags & PF_SPINNING) then
		if p.mo.state ~= S_PLAY_GPLD
			if p.rollWindow ~= true
				p.wasCrouching = true
				p.mariocrouching = $1+1
			elseif (inRaceCountdown() == false)
				p.mo.state = S_PLAY_ROLL
				p.pflags = $|PF_SPINNING
				p.rolling = true
				//if p.speed < 20*FRACUNIT
					if (p.pflags & PF_ANALOGMODE)
					and not (p.pflags & PF_DIRECTIONCHAR)
						p.drawangle = p.mo.angle
					elseif not (p.pflags & PF_ANALOGMODE)
						p.drawangle = p.mo.angle
					end
					P_InstaThrust(p.mo, p.drawangle, 48*FRACUNIT)
				//end
				S_StartSound(p.mo, sfx_sgrol)
				DoSpinDashDust(p, p.normalspeed)
				p.rollDelay = 8
			end
		elseif (inRaceCountdown() == false)
			
			p.mo.state = S_PLAY_ROLL
			p.pflags = $|PF_SPINNING
			p.rolling = true
			//if p.speed < 20
				P_InstaThrust(p.mo, p.drawangle, 64*FRACUNIT)
			//end
			DoSpinDashDust(p, p.normalspeed)
			S_StartSound(p.mo, sfx_sgrls)
			if (p.pflags & PF_ANALOGMODE)
			and not (p.pflags & PF_DIRECTIONCHAR)
				p.drawangle = p.mo.angle
			elseif not (p.pflags & PF_ANALOGMODE)
				p.drawangle = p.mo.angle
			end
			P_InstaThrust(p.mo, p.drawangle, 64*FRACUNIT)
			DoSpinDashDust(p, p.normalspeed)
			p.rollDelay = 8
		end
	end
	return true
end
SGIPoundBegin = function(p)
	if p.powers[pw_super] ~= 0
	and p.metalMode <= 45
		return
	end
	if p.hitSpring == true
		return
	end
	if p.sgiLunge == true then 
		p.sgiLunge = false
		if (p.pflags & PF_SPINNING)
			p.pflags = p.pflags & ~PF_SPINNING
		end
	end
	if not (p.pflags & PF_SPINNING) 
		if (p.powers[pw_shield] ~= 0 and p.powers[pw_shield] ~= 1 and p.powers[pw_shield] ~= 512) and (p.powers[pw_super] == 0) then 
			if p.powers[pw_shield] ~= 3073 --Go straight to Super-Rolling with the Elemental Shield.
				if p.sPoundDelay <= 0 
				and p.powers[pw_shield] ~= 2049 --This ability is incredibly redundant with the Bubble Shield.
				and p.shieldUsed == true
				and p.spinHit ~= true
					if p.wasRiding ~= true
						if p.marioGPound <= 0 
							S_StartSound(p.mo, sfx_sgpds)
							p.mo.state = S_PLAY_GPST
							p.poundX = p.mo.x
							p.poundY = p.mo.y
							p.poundZ = p.mo.z
							
							p.spinHit = true
						end
					p.marioGPound = $1+1
					
					end
				else
					p.shieldUsed = true
					p.sPoundWindow = true 
					p.spinHit = true
				end
			else
				p.usedElemental = true
			end
			return 
		else
			if p.wasRiding ~= true
			and p.mo.state == S_PLAY_JUMP then
				if p.marioGPound <= 0 
					S_StartSound(p.mo, sfx_sgpds)
					p.mo.state = S_PLAY_GPST
					p.poundX = p.mo.x
					p.poundY = p.mo.y
					p.poundZ = p.mo.z
					
				end
				p.marioGPound = $1+1
			end
		end
	else
		if (p.powers[pw_shield] ~= 0 and p.powers[pw_shield] ~= 1 and p.powers[pw_shield] ~= 512) and p.powers[pw_super] == 0 then
			if p.powers[pw_shield] ~= 3073 --Go straight to Super-Rolling with the Elemental Shield.
				if p.sPoundDelay <= 0 
				and p.powers[pw_shield] ~= 2049 --This ability is incredibly redundant with the Bubble Shield.
				and p.shieldUsed == true
				and p.spinHit ~= true
					if p.wasRiding ~= true
						if p.marioGPound <= 0 
							p.pflags = p.pflags & ~PF_SPINNING
							S_StartSound(p.mo, sfx_sgpds)
							p.mo.state = S_PLAY_GPST
							p.poundX = p.mo.x
							p.poundY = p.mo.y
							p.poundZ = p.mo.z
							p.spinHit = true
						end
					p.marioGPound = $1+1
					end
				else
					p.shieldUsed = true
					p.sPoundWindow = true 
					p.spinHit = true
				end
			else
				p.usedElemental = true
			end
			return 
		else
			if p.wasRiding ~= true
			and p.mo.state == S_PLAY_JUMP then
				if p.marioGPound <= 0 
					p.pflags = p.pflags & ~PF_SPINNING
					S_StartSound(p.mo, sfx_sgpds)
					p.mo.state = S_PLAY_GPST
					p.poundX = p.mo.x
					p.poundY = p.mo.y
					p.poundZ = p.mo.z
					
				end
				p.marioGPound = $1+1
			end
		end
	end
end
SGIBlockBust = function(p)
	local mo = p.mo
	if p.busted == true then return end
	if not P_IsObjectOnGround(p.mo) then return end
	if mo.state ~= S_PLAY_GPLD and p.powers[pw_shield] ~= 3073 then return end
	if CanPound(p) ~= true then return end
	local flRover = mo.floorrover
	
	EV_CrumbleChain(mo.subsector.sector, flRover)
	if (flRover.master.flags & ML_EFFECT5)
		P_LinedefExecute(P_AproxDistance(flRover.master.dx, flRover.master.dy)>>FRACBITS, mo, mo.subsector.sector)
	end
	
	if P_MobjFlip(p.mo) > 0
	mo.momz = 4
	else
	mo.momz = -4
	end
	p.pflags = $|(PF_JUMPED|PF_SPINNING)
	if p.powers[pw_shield] ~= 3073
		mo.state = S_PLAY_GRPD
	else
		mo.state = S_PLAY_ROLL
	end
	P_SetObjectMomZ(mo, 5*FRACUNIT/((mo.eflags & MFE_UNDERWATER) and 2 or 1))
	S_StartSound(mo, sfx_crumbl)
	p.busted = true
end
SGICrouching = function(p)
	-- Brake
	-- I tried height-changing and crawling, but it wasn't as safe as I wanted my final prototype to be.
	p.rolling = false
	if p.crawlCooldown > 0
		p.normalspeed = 0
	else
		//p.normalspeed = 8
	end
	p.thrustfactor = 0
	
	if p.mariogrounded then
		if p.crawlCooldown > 3
			if not checkAxis2D(p.mo)
				PlayerBrake(p.mo, 48)
			else
				p.pflags = $|PF_STASIS
			end
		else
			if checkAxis2D(p.mo)
			and (p.pflags & PF_STASIS)
				p.pflags = p.pflags & ~PF_STASIS
			end
			if ((p.pflags & PF_DIRECTIONCHAR) == 0)
				if not (mobj2DCheck(p.mo) or checkAxis2D(p.mo))
					if p.cmd.forwardmove ~= 0 or p.cmd.sidemove ~= 0
						p.mo.momx = (((p.cmd.forwardmove/10))*cos(p.mo.angle)+((p.cmd.sidemove/10)*cos(p.mo.angle-ANGLE_90)))+(p.cmomx)
						p.mo.momy = (((p.cmd.forwardmove/10))*sin(p.mo.angle)+((p.cmd.sidemove/10)*sin(p.mo.angle-ANGLE_90)))+(p.cmomy)
					end
				else
					if p.crawlMove == true
						p.mo.momx = (5*cos(p.drawangle))+(p.cmomx)
						p.mo.momy = (5*sin(p.drawangle))+(p.cmomy)
					end
				end
			else
				if p.crawlMove == true
					p.mo.momx = (5*cos(p.drawangle))+(p.cmomx)
					p.mo.momy = (5*sin(p.drawangle))+(p.cmomy)
				end
			end
			if p.cmd.forwardmove ~= 0 or p.cmd.sidemove ~= 0
				//P_InstaThrust(p.mo, p.drawangle, 5*FRACUNIT);
				p.crawlMove = true
			else
				p.crawlMove = false
			end
		end
		if p.crawlCooldown > 0
			p.mo.state = S_PLAY_DUCK
		else
			if p.crawlMove == false
				p.mo.state = S_PLAY_CRSD
			else
				if p.crawlDelay >= 3
					p.mo.state = S_PLAY_CRMV
					p.crawlDelay = 0
				end
			end
		end
		if p.mariocrouching == 1 then
			if (PlayerSpeed(p) > skins.sgimario.normalspeed * 5/8) then
				-- "Braking"
				P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SPINDUST)
				//S_StartSound(p.mo, sfx_skid)
			end
		end
	end
	
	-- Uncrouch
	if not (p.pflags & PF_USEDOWN) or (not P_IsObjectOnGround(p.mo)) then
		p.rollWindow = true
		p.mariocrouching = 0
		if (p.mo.state == S_PLAY_DUCK) or (p.crawlCooldown < 0) then
			if checkAxis2D(p.mo)
			and (p.pflags & PF_STASIS)
				p.pflags = p.pflags & ~PF_STASIS
			end
			p.crawlCooldown = 45
			if P_IsObjectOnGround(p.mo)
				p.mo.state = S_PLAY_STND
			else
				if p.playerstate ~= PST_DEAD
					p.mo.state = S_PLAY_JUMP
				else
					p.mo.state = S_PLAY_DEAD
				end
			end
		end
	end
end

-- Return the in-world angle of the player's WASD/joystick direction,
-- or straight ahead if no direction is held.
-- (There should be a native P_ function for this. STJr pls)
WASDAngle = function(p)
	if p.player then p = p.player end
	local plus = 0
	if p.cmd.sidemove then
		if p.cmd.forwardmove > 0 then plus = ANGLE_45
		elseif p.cmd.forwardmove < 0 then plus = ANGLE_135
		else plus = ANGLE_90 end
		if p.cmd.sidemove > 0 then plus = -$1 end
	elseif p.cmd.forwardmove < 0 then plus = ANGLE_180 end
	return p.mo.angle + plus
end
-- Get the player's speed, corrected for scale.
PlayerSpeed = function(p)
	return FixedDiv(p.speed, p.mo.scale)
end

DoSpinDashDust = function(player, speed) // From the source code!
	local mo = player.mo
	local prandom = {}
	for i = 0, (leveltime%7) >> 1 // 1, 2, 3 or 4 particles
		local particle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SPINDUST)

		if mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER) // overrides fire version
			particle.state = S_SPINDUST_BUBBLE1
		elseif player.powers[pw_shield] == SH_ELEMENTAL
			particle.state = S_SPINDUST_FIRE1
		end

		particle.target = mo
		particle.destscale = (mo.destscale << 1)/3
		P_SetScale(particle, particle.destscale)
		if mo.eflags & MFE_VERTICALFLIP // readjust z position if needed
			particle.z = mo.z + mo.height - particle.height
		end
		prandom[0] = P_RandomFixed()<<2 // P_RandomByte()<<10
		prandom[1] = P_RandomRange(-30, 30) // P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT
		prandom[2] = P_RandomFixed()<<3 // P_RandomByte()<<11
		P_SetObjectMomZ(particle, speed/50 + prandom[0], false)
		P_InstaThrust(particle,
				player.drawangle + prandom[1]*ANG1,
				-FixedMul(speed/12 + FRACUNIT + prandom[2], mo.scale))
		P_TryMove(particle, particle.x + particle.momx, particle.y + particle.momy, true)
	end
end
-- PlayerBrake
-- Slows the player down.
-- Higher values apply less braking power, and are good for slowing gradually.
-- Lower values are good for instantly slowing down in a single tic.
PlayerBrake = function(p, f)
	if p.player then p = p.player end
	local s = 1
	if not f or (f <= 1) then f = 1
	elseif (p.mo.eflags & MFE_UNDERWATER) then s = 2 end
	p.mo.momx = $1 * (f-s) / f
	p.mo.momy = $1 * (f-s) / f
end
-- Initialize variables
addHook("PlayerSpawn", function(p)
	p.hrtVoice = false
	p.jmpVoice = false
	p.tfmVoice = false
	p.damage2 = false
	p.axisAngle = 0
	p.underwaterCheck = false
	p.startAngle = p.mo.angle
	p.prevAngle = p.mo.angle
	p.newPrev = p.mo.angle
end)
addHook("PlayerSpawn", SGIMReset)
-- Hold B on the ground to crouch.
addHook("SpinSpecial", function(p)
	if p.mo.skin ~= "sgimario" then return false end
	if P_PlayerInPain(p) or p.deadtimer then return false end
	if p.mo.state == S_PLAY_LGST or p.mo.state == S_PLAY_LNGE or p.mo.state == S_PLAY_LGFL then return true end
	if P_IsObjectOnGround(p.mo) ~= true 
		if p.powers[pw_super] == 0 
			if emeralds ~= 127 and (All7Emeralds(p.powers[pw_emeralds]) ~= true) then 
				if p.swimming ~= true
					return SGIPoundBegin(p) 
				else
					if p.swDrill ~= true
					and p.swDrBtn ~= true
						S_StartSound(p.mo, sfx_drill1)
						if ((p.pflags & PF_DIRECTIONCHAR) == 0)
							p.swAngLock = p.mo.angle
						else
							if (mobj2DCheck(p.mo) or checkAxis2D(p.mo))
								p.swAngLock = p.mo.angle
							else
								p.swAngLock = p.drawangle
							end
						end
						p.mo.state = S_PLAY_SWDR
						p.pflags = p.pflags & ~PF_NOJUMPDAMAGE
						if checkAxis2D(p.mo)
							if p.mo.isfacingleft
								p.axisLock = 0
							else
								p.axisLock = 1
							end
							p.pflags = $|PF_STASIS
						end
						p.swDrill = true
						p.swDrBtn = true
					end
				end
			else
				if p.rings < 50 and p.swimming ~= true
					return SGIPoundBegin(p) 
				else
					if p.swimming == true
						if	p.rings < 50
							if p.swDrill ~= true
							and p.swDrBtn ~= true
							and p.mo.state ~= S_PLAY_SWDG
								S_StartSound(p.mo, sfx_drill1)
								if ((p.pflags & PF_DIRECTIONCHAR) == 0)
									p.swAngLock = p.mo.angle
								else
									if (mobj2DCheck(p.mo) or checkAxis2D(p.mo))
										p.swAngLock = p.mo.angle
									else
										p.swAngLock = p.drawangle
									end
								end
								p.mo.state = S_PLAY_SWDR
								p.pflags = p.pflags & ~PF_NOJUMPDAMAGE
								if checkAxis2D(p.mo)
									if p.mo.isfacingleft
										p.axisLock = 0
									else
										p.axisLock = 1
									end
									p.pflags = $|PF_STASIS
								end
								p.swDrill = true
								p.swDrBtn = true
							end
						else
							if p.jmpVoice ~= true
								if p.swDrill ~= true
								and p.swDrBtn ~= true
								and p.mo.state ~= S_PLAY_SWDG
									S_StartSound(p.mo, sfx_drill1)
									if ((p.pflags & PF_DIRECTIONCHAR) == 0)
										p.swAngLock = p.mo.angle
									else
										if (mobj2DCheck(p.mo) or checkAxis2D(p.mo))
											p.swAngLock = p.mo.angle
										else
											p.swAngLock = p.drawangle
										end
									end
									p.mo.state = S_PLAY_SWDR
									p.pflags = p.pflags & ~PF_NOJUMPDAMAGE
									if checkAxis2D(p.mo)
										if p.mo.isfacingleft
											p.axisLock = 0
										else
											p.axisLock = 1
										end
										p.pflags = $|PF_STASIS
									end
									p.swDrBtn = true
									p.swDrill = true
								end
							else
								if p.powers[pw_shield] ~= 0
									if p.swDrill ~= true
									and p.swDrBtn ~= true
									and p.mo.state ~= S_PLAY_SWDG
										S_StartSound(p.mo, sfx_drill1)
										if ((p.pflags & PF_DIRECTIONCHAR) == 0)
											
											p.swAngLock = p.mo.angle
										else
											if (mobj2DCheck(p.mo) or checkAxis2D(p.mo))
												p.swAngLock = p.mo.angle
											else
												p.swAngLock = p.drawangle
											end
										end
										p.mo.state = S_PLAY_SWDR
										p.pflags = p.pflags & ~PF_NOJUMPDAMAGE
										if checkAxis2D(p.mo)
											if p.mo.isfacingleft
												p.axisLock = 0
											else
												p.axisLock = 1
											end
											p.pflags = $|PF_STASIS
										end
										p.swDrBtn = true
										p.swDrill = true
									end
								else
									p.swDrill = false
									p.swimming = false
									return true
								end
							end
						end
					else
						
						return true
					end
				end
			end
		end
		if p.powers[pw_super] ~= 0
			if (p.metalMode > 45) 
				return SGIPoundBegin(p) 
			else
				return true 
			end
		end
	end
	if not CanCrouch(p) then return true end
	if p.marioGPound and p.mo.state ~= S_PLAY_GPLD then return true end
	return SGICrouchBegin(p)
end)
//super theme (fucking broken)
addHook("MusicChange", function(oldname, newname, mflags, looping)
	local switchTheme = true
	for p in players.iterate do
		if p.marioCheck ~= 0 then
			if superTheme[newname] and switchTheme == true
				return superTheme[newname]
			end
		end
	end
end)
addHook("PlayerThink", function(p)
	if not p.mo return end
	if p.mo.skin ~= "sgimario" then return end
	if P_PlayerInPain(p) or p.deadtimer then return end
	if p.powers[pw_carry] then return end
	if (p.cmd.buttons & BT_CUSTOM1)
		if p.pressSpecial ~= true
			if p.swimming == true
				p.mo.state = S_PLAY_SWID
				p.swimming = false
			end
			p.pressSpecial = true
		end
	else
		p.pressSpecial = false
	end
	if not (p.cmd.buttons & BT_USE or p.cmd.buttons & BT_JUMP)
		if p.spinHit ~= false
			p.spinHit = false
		end
	end
	if P_IsObjectOnGround(p.mo) ~= true
		if not (p.cmd.buttons & BT_USE or p.cmd.buttons & BT_JUMP)
			if p.gpJump ~= 0 then
				p.gpJump = 0
			end
			if p.slideJump ~= 0 then
				p.slideJump = 0
			end
			if p.carryState ~= 0 then
				p.carryState = 0
			end
			if p.swimJumpBuffer ~= 0 
			and p.swimming == true then
				p.swimJumpBuffer = 0
			end
		end
	else
		p.swimUp = false
		if (p.cmd.buttons & BT_JUMP)
			p.hitHoriz = false
		end
	end
	
end)
local function playercollide(mo, ring)
	--bumper bug shit lol! many thanks to golden shine for the original code
    if mo.valid and ring and ring.valid and (ring.type == MT_BUMPER)
		local plr = nil
		for p in players.iterate do
			if mo == p.mo
				plr = p
			end
		end
        if (mo.z > ring.z+ring.height)
        or (ring.z > mo.z+mo.height)
        return
        end
		if mo.skin ~= "sgimario" then return end
		if plr.marioGPound == 0 then return end
        plr.marioGPound = 0
        return nil

    end
	if mo.valid and ring and ring.valid and ((ring.type == MT_YELLOWHORIZ) or (ring.type == MT_REDHORIZ) or (ring.type == MT_BLUEHORIZ))
		local plr = nil
		for p in players.iterate do
			if mo == p.mo
				plr = p
			end
		end
        if (mo.z > ring.z+ring.height)
        or (ring.z > mo.z+mo.height)
        return
        end
		if mo.skin ~= "sgimario" then return end
			/*if plr.superman == false -- do NOT re-enable, will break the lunge
				plr.hitHoriz = true
			end*/
			plr.horizHit2 = true
		return nil
	end
	if mo.valid and ring and ring.valid and ((ring.type == MT_YELLOWBOOSTER) or (ring.type == MT_REDBOOSTER))
		--booster bug shit, as you could guess mario's moveset breaks more than the game
		local plr = nil
		for p in players.iterate do
			if mo == p.mo
				plr = p
			end
		end
        if (mo.z > ring.z+ring.height)
        or (ring.z > mo.z+mo.height)
        return
        end
		if mo.skin ~= "sgimario" then return end
			plr.boostBuffer = 0
			//print("RESET THE BUFFER ASSHOLE")
			//plr.hitHoriz = true
			plr.hitBooster = true
			//print("noooo mooore superman! *vine thud*")
        return nil

	end
end

addHook("MobjCollide", playercollide, MT_PLAYER)
addHook("MobjMoveCollide", playercollide, MT_PLAYER)
addHook("JumpSpecial", function(p) 
	if p.mo.skin ~= "sgimario" then return false end
	if P_PlayerInPain(p) or p.deadtimer then return false end
	if (p.pflags & PF_SLIDING)
		p.slideJump = 1
		p.mo.state = S_PLAY_JUMP
		p.wasSliding = false
	end
	if p.powers[pw_carry] then return false end
	if P_IsObjectInGoop(p.mo)
		if p.sgiLunge == false
		and DoJumpSpecial(p)
		and not (p.gotflag & (GF_REDFLAG|GF_BLUEFLAG))
		//and p.lungeTimer >= 18
			if P_MobjFlip(p.mo) > 0
				if p.mo.momz >= -30*FRACUNIT
					p.mo.momz = 6*FRACUNIT
				end
				S_StartSound(p.mo, sfx_sgjm2)
				S_StartSound(p.mo, sfx_sglng)
				p.pflags = p.pflags & ~PF_NOJUMPDAMAGE
				p.drawangle = p.mo.angle
				doLungeJump(p)
			else
				if p.mo.momz <= 30*FRACUNIT
					p.mo.momz = -6*FRACUNIT
				end
				S_StartSound(p.mo, sfx_sgjm2)
				S_StartSound(p.mo, sfx_sglng)
				p.pflags = p.pflags & ~PF_NOJUMPDAMAGE
				p.drawangle = p.mo.angle
				
				doLungeJump(p)
			end
			p.mo.state = S_PLAY_LGST
			p.sgiLunge = true
		end
	end
	if not P_IsObjectOnGround(p.mo) and not p.powers[pw_carry] then 
		if p.swimming ~= true
			if p.underwaterCheck ~= false
				if DoJumpSpecial(p)
					if p.swimming ~= true
						if P_IsObjectInGoop(p.mo) ~= true
						and (p.pflags & PF_SLIDING) == 0
						and P_IsObjectOnGround(p.mo) ~= true
							if (p.pflags & PF_SPINNING)
								p.pflags = p.pflags & ~PF_SPINNING
							end
							S_StartSound(p.mo, sfx_sgsws)
							p.mo.state = S_PLAY_SWST
							p.swimDelay = 0
							p.swimFrame = 0
							p.swimSpeed = 0
							p.setSwSpeed = false
							p.swimming = true
							p.swimJumpBuffer = 1
						end
					end
				end
			else
				if p.sgiLunge == false
				and DoJumpSpecial(p)
				and not (p.gotflag & (GF_REDFLAG|GF_BLUEFLAG))
				//and p.lungeTimer >= 18
					if P_MobjFlip(p.mo) > 0
						if p.mo.momz >= -30*FRACUNIT
							p.mo.momz = 6*FRACUNIT
						else
							p.mo.momz = ($1/4)*3
						end
						S_StartSound(p.mo, sfx_sgjm2)
						S_StartSound(p.mo, sfx_sglng)
						p.pflags = p.pflags & ~PF_NOJUMPDAMAGE
						p.drawangle = p.mo.angle
						doLungeJump(p)
					else
						if p.mo.momz <= 30*FRACUNIT
							p.mo.momz = -6*FRACUNIT
						else
							p.mo.momz = ($1/4)*3
						end
						S_StartSound(p.mo, sfx_sgjm2)
						S_StartSound(p.mo, sfx_sglng)
						p.pflags = p.pflags & ~PF_NOJUMPDAMAGE
						p.drawangle = p.mo.angle
						doLungeJump(p)
					end
					p.mo.state = S_PLAY_LGST
					p.sgiLunge = true
				end
			end
		else
			if p.mo.state ~= S_PLAY_SWDR
				if p.swimJumpBuffer == 0
				and p.swimUp ~= true
					S_StartSound(p.mo, sfx_sgswj)
					if P_MobjFlip(p.mo) > 0
						p.mo.momz = 9*FRACUNIT
					else
						p.mo.momz = -9*FRACUNIT
					end
					p.mo.state = S_PLAY_SWJP
					p.swJpAnim = true
					p.swimUp = true
				end
			end
		end
		return true 
	end
	if p.marioGPound == 0 then return false end
	if p.marioGPound and p.mo.state ~= S_PLAY_GPLD then return true end
	p.gpJump = 1
	if P_MobjFlip(p.mo) > 0
		p.mo.state = S_PLAY_JUMP
		p.mo.z = $1+(15*FRACUNIT)
		p.mo.momz = 18*FRACUNIT
		p.marioGPound = 0
	else
		p.mo.state = S_PLAY_JUMP
		p.mo.z = $1-(15*FRACUNIT)
		p.mo.momz = -18*FRACUNIT
		p.marioGPound = 0
	end
end)
addHook("ThinkFrame", do
	for p in players.iterate do
		if not p.mo return end
		if p.mo.skin == "sgimario" then 
			if p.underwaterCheck == true
			and p.swimming ~= true
				if P_PlayerInPain(p)
					p.mo.state = S_PLAY_UWDG
				end
			end
			if p.powers[pw_spacetime] ~= 0
			and p.powers[pw_super] == 0
				if P_PlayerInPain(p)
					p.damage2 = true
					S_StartSound(p.mo, sfx_sgswd)
					p.mo.state = S_PLAY_UWDG
				end
			end
			if p.mo.state == S_PLAY_UWDG
				p.powers[pw_flashing]=105
				p.waterDamage = true
				if not (p.pflags & PF_STASIS)
					p.pflags = $|PF_STASIS
				end
			else
				if p.waterDamage == true
					if p.powers[pw_flashing] > 0
						p.powers[pw_flashing] = $1 - 1
					else
						p.waterDamage = false
					end
				end
				if p.damage2 ~= false
					if (p.pflags & PF_STASIS)
						p.pflags = (p.pflags & ~PF_STASIS)
					end
					p.damage2 = false
				end
			end
			SGIPassive(p) 
			
		else SGIMReset(p) end
	end
end)